image: dart:stable

stages:
  - check
  - deploy

before_script:
  - dart pub global activate webdev
  - pub get

cache:
  paths:
    - .dart_tool

formatting:
  stage: check
  script:
    - dart format web
    # Exit if code in repo has changed due to running `dart format`, meaning that it was wrongly formatted before
    - git diff --exit-code  

unit_tests:
  stage: check
  script: 
    - dart run test web
  
code_check:
  stage: check
  script:
    - dart run dart_code_metrics:metrics web --set-exit-on-violation-level=warning

pages:
  stage: deploy
  script:
    - ~/.pub-cache/bin/webdev build
    # Reason: https://stackoverflow.com/questions/45505610/gitlab-pages-deployment-step-fails-after-successfull-build
    - mv build public   
  artifacts:
    paths:
      - public 
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH

